package Conifer;
use 5.010001;
use utf8;
use Mojo::Base 'Mojolicious';
use Data::Dumper;
use Mojo::ByteStream 'b';
#~ use Redis;
use MojoX::Redis;
#~ use Text::Xslate;
use MojoX::Renderer::Xslate;
use Mojolicious::Plugin::Proxy;
#~ use namespace::clean;
use EV;
use AnyEvent;

my %redis_server = (server => '127.0.0.1:6379');
my $secret = '';

#~ __PACKAGE__->attr('redis');

#~ __PACKAGE__->redis( Redis->new(%redis_server) );
has redis	=> sub { MojoX::Redis->new( ioloop => Mojo::IOLoop->new, %redis_server) };
#~ print Dumper __PACKAGE__->redis;


# This method will run once at server start
sub startup {
	my $self = shift;
	
	say $self->dumper($self->redis);
	
	#####
	# Routes
	#####
	
	# Documentation browser under "/perldoc" (this plugin requires Perl 5.10)
	#~ $self->plugin('PODRenderer');
	
	# use Xslate for page rendering
	$self->plugin('xslate_renderer');
	$self->plugin('proxy');
	
	# bring in key_* and time_and_rand
	$self->plugin('Conifer::Plugin::Helpers');
	$self->plugin('Conifer::Plugin::DataHelpers');
	$self->plugin('Conifer::Plugin::UserHelpers');
	
	$self->secret($secret);

	# Routes
	my $r = $self->routes;
	# $r->route('/:controller/:action/:id')->to('example#welcome', id => 1)->name('named');
	
	
	# Pages
	$r->get('/')->to('page#lijibo')->name('root');
	#~ $r->get('/index')->to('page#lijibo')->name('index-real');
	#~ $r->get('/sport-live-broadcast-schedule-list')->to('page#castlist')->name('index');
	$r->get('/lijibo')->to('page#lijibo')->name('page-lijibo');
	$r->get('/sport-live-broadcast-schedule-list')->to('page#castlist')->name('page-castlist');
	$r->get('/index')->to('page#lijibo')->name('index');
	$r->get('/admin')->to('page#admin')->name('page-admin');
	$r->get('/login')->to('page#login')->name('page-login');
	$r->get('/logout')->to('page#logout')->name('page-logout');
	$r->get('/register')->to('page#register')->name('page-register');
	# New things
	$r->get('/new/article')->to('page#new_article')->name('new-article');
	$r->get('/new/ads')->to('page#new_ads')->name('new-ads');
	$r->get('/new/board')->to('page#new_board')->name('new-board');
	$r->get('/new/forum')->to('page#new_forum')->name('new-forum');
	# Redirects
	$r->get('/Live')->to('page#redir_livescore');
	$r->get('/info/sport-live-broadcast-schedule-list')->to('page#castlist');
	
	
	# User
	#~ $r->get('/user/info')->to('user#info')->name('user-info');
	$r->get('/user/login')->to('user#login')->name('user-login');
	$r->get('/user/logout')->to('user#logout')->name('user-logout');
	$r->post('/user/register')->to('user#register')->name('user-register');
	$r->get('/user/:name')->to('user#info')->name('user-info');
	
	
	# Article
	$r->get('/article')->to('article#list')->name('article-list');
	$r->get('/article/(.hash)')->to('article#show')->name('article-show');
	$r->post('/create/post/(.board)')->to('article#create')->name('article-create');
	
	
	# Ads
	$r->get('/ads')->to('ads#list')->name('ads-list');
	$r->get('/ads/(.hash)')->to('ads#show')->name('ads-show');
	$r->post('/create/ads')->to('ads#create')->name('ads-create');
	
	
	# Board
	$r->get('/board')->to('board#list')->name('board-list');
	$r->get('/board/(.board)')->to('board#show')->name('board-show');
	$r->post('/create/board')->to('board#create')->name('board-create');
	
	
	# Forum
	$r->get('/forum')->to('forum#list')->name('forum-list');
	$r->get('/forum/(.forum)')->to('forum#show')->name('forum-show');
	$r->post('/create/forum')->to('forum#create')->name('forum-create');
	
	
	# Informations
	$r->get('/info/castlist')->to('info#castlist')->name('info-castlist');
	$r->get('/info/sport-live-score-board-list')->to('info#livescore')->name('info-livescore');
	
	
	# TEST
	$r->route('/test/echo/(.word)')->to('test#echo');
	$r->get('/test/proxy/(.site)')->to('test#proxy');
	$r->get('/test/nested')->to('test#nested_tpl');
	$r->get('/test/parallel')->to('test#parallel');
	$r->get('/test/paratest')->to('test#paratest');
	$r->get('/test/keygen')->to('test#keygen');
	
}

1;
