package Conifer::Ads;
use 5.010001;
use utf8;
use Conifer;
use Mojo::Base 'Mojolicious::Controller';
use Time::HiRes 'time', 'gettimeofday';
use Data::Dumper::Simple;
#~ use Digest::SHA1 qw(sha1_hex sha1_base64);
#~ use Digest::MD5 qw(md5 md5_hex md5_base64);
use MIME::Base64;

$|=1;


sub create {
	my $c = shift;
	my $user = $c->session('name');
	
	# Already login
	unless ($user) {
		$c->flash(message => 'Please login first.');
		$c->redirect_to('page-login');
	}
	
	
	my %ads;
	#~ ( $ads{'title'}, $ads{'content'} ) = ($self->req->param('title'), $self->req->param('content'));
	$ads{'title'} = $c->req->param('title');
	$ads{'content'} = $c->req->param('content');
	$ads{'author'} = $user;
	
	
	my $date_string = $c->time_and_rand;
	$date_string =~ s/[\.-]//g;
	
	#~ print "DATE_STRING: $date_string\n";
	
	my ($id, $hash) = $c->add_data(\%ads);
	
	Conifer->redis->zadd("ads:list", $date_string, $id);
	Conifer->redis->zadd("board:ads:posts", $date_string, $id);
	
	
	$c->redirect_to("/ads/$hash");
}

sub show {
	# /(.who)/fuck/(.whom)
	my $c = shift;
	my $hash = $c->param('hash');
	#~ my $who = $self->param('who') || 'anon';
	#~ my ($whom, $hash) = split/:/,$self->param('whom');
	#~ $whom ||= 'anon';
	
	#~ my $post_id = &_key_lookup("data",$hash);
	
	my ($data_id, $data) = $c->get_data($hash, "title", "content", "author");
	
	#~ my $title = Conifer->redis->get("article:$post_id:title");
	#~ my $content = Conifer->redis->get("article:$post_id:content");
	#~ my $author = Conifer->redis->get("article:$post_id:author");
	
	#~ my $motd = "A Fuck A Day, keeps the doctor away.";
	
	$c->render( title => $data->{'title'}, content => $data->{'content'}, author => $data->{'author'} );
}

sub list {
	# /(.who)/fuck/(.whom)
	my $c = shift;
	#~ my $hash = $self->param('hash');
	
	$c->render_later;
	
	#~ my @post_ids = Conifer->redis->zrange("ads:list", 0, -1);
	my $post_ids = $c->get_list("ads:list", 0, -1);
	#~ say "Ads: list:\n\tpost_ids: ". Dumper($post_ids);
	
	my @all_posts;
	for (@$post_ids) {
		#~ my %post;
		my $hash = encode_base64($_->[0]);
		chomp $hash;
		$hash =~ s/=//g;
		
		#~ $post{'hash'} = $hash;
		#~ $post{'title'} = Conifer->redis->get("article:$_:title");
		#~ $post{'content'} = Conifer->redis->get("article:$_:content");
		#~ $post{'author'} = Conifer->redis->get("article:$_:author");
		my ($data_id, $data) = $c->get_data($hash, "title", "content", "author");
		$data->{'hash'} = $hash;
		
		push @all_posts, $data;
	}
	
	$c->render(all_ads => \@all_posts);
}

1;
