package Conifer::Article;
use 5.010001;
use utf8;
use Conifer;
use Mojo::Base 'Mojolicious::Controller';
use Time::HiRes 'time', 'gettimeofday';
use Data::Dumper::Simple;
#~ use Digest::SHA1 qw(sha1_hex sha1_base64);
#~ use Digest::MD5 qw(md5 md5_hex md5_base64);
use MIME::Base64;

$|=1;

my %hash_table;


sub create {
	my $c = shift;
	#~ my ($board) = $self->param('board');	# board id
	#~ my $board = 1;
	my $board = $c->req->param('board');
	my $user = $c->session('name');
	
	# Already login
	unless ($user) {
		$c->flash(message => 'Please login first.');
		$c->redirect_to('page-login');
	}
	
	# Check login status
	#~ $self->redirect_to('/user/login') unless $user;
	
	my %article;
	#~ my ($title, $content, $board) = ($c->req->param('title'), $c->req->param('content'), $c->req->param('board'));
	$article{'title'} = $c->req->param('title');
	$article{'content'} = $c->req->param('content');
	$article{'author'} = $user;
	
	
	my $date_string = $c->time_and_rand;
	$date_string =~ s/[\.-]//g;
	
	#~ print "DATE_STRING: $date_string\n";
	
	#~ Conifer->redis->set("article:$post_id:title" => $title);
	#~ Conifer->redis->set("article:$post_id:content" => $content);
	#~ Conifer->redis->set("article:$post_id:author" => $user);
	my ($id, $hash) = $c->add_data(\%article);
	
	Conifer->redis->zadd("article:list", $date_string, $id);
	Conifer->redis->zadd("board:$board:posts", $date_string, $id);
	
	
	$c->redirect_to("/article/$hash");
}

sub show {
	# /(.who)/fuck/(.whom)
	my $c = shift;
	my $hash = $c->param('hash');
	#~ my $who = $self->param('who') || 'anon';
	#~ my ($whom, $hash) = split/:/,$self->param('whom');
	#~ $whom ||= 'anon';
	
	my $post_id = $c->key_lookup("article",$hash);
	
	#~ my $title = Conifer->redis->get("article:$post_id:title");
	#~ my $content = Conifer->redis->get("article:$post_id:content");
	#~ my $author = Conifer->redis->get("article:$post_id:author");
	
	my ($data_id, $data) = $c->get_data($hash, "title", "content", "author");
	
	#~ my $motd = "A Fuck A Day, keeps the doctor away.";
	
	#~ $c->render(title => "$title", content => "$content", author => "$author");
	$c->render( title => $data->{'title'}, content => $data->{'content'}, author => $data->{'author'} );
}

sub list {
	# /(.who)/fuck/(.whom)
	my $c = shift;
	#~ my $hash = $self->param('hash');
	
	#~ my @post_ids = Conifer->redis->zrange("article:list", 0, -1);
	my $post_ids = $c->get_list("article:list", 0, -1);
	say "Ads: list:\n\tpost_ids: ". Dumper($post_ids);
	
	my @all_posts;
	for (@$post_ids) {
		my %post;
		my $hash = encode_base64($_->[0]);
		chomp $hash;
		$hash =~ s/=//g;
		
		#~ $post{'hash'} = $hash;
		#~ $post{'title'} = Conifer->redis->get("article:$_:title");
		#~ $post{'content'} = Conifer->redis->get("article:$_:content");
		#~ $post{'author'} = Conifer->redis->get("article:$_:author");
		my ($data_id, $data) = $c->get_data($hash, "title", "content", "author");
		$data->{'hash'} = $hash;
		
		push @all_posts, $data;
		#~ push @all_posts, \%post;
	}
	
	$c->render(all_posts => \@all_posts);
}

1;
