package Conifer::Board;
use 5.010001;
use utf8;
use Conifer;
use Mojo::Base 'Mojolicious::Controller';
use Time::HiRes 'time', 'gettimeofday';
use Data::Dumper::Simple;
#~ use Digest::SHA1 qw(sha1_hex sha1_base64);
#~ use Digest::MD5 qw(md5 md5_hex md5_base64);
use MIME::Base64;

$|=1;

my %hash_table;


sub create {
	my $c = shift;
	#~ my ($board) = $self->param('board');	# board id
	my $user = $c->session('name');
	
	# Already login
	unless ($user) {
		$c->flash(message => 'Please login first.');
		$c->redirect_to('page-login');
	}
	
	# Check login status
	#~ $self->redirect_to('/user/login') unless $user;
	
	my ($title, $desc) = ($c->req->param('title'), $c->req->param('desc'));
	
	
	my ($bid, $hash) = $c->key_gen("board");
	my $date_string = $c->time_and_rand;
	$date_string =~ s/[\.-]//g;
	
	print "DATE_STRING: $date_string\n";
	
	Conifer->redis->set("board:$bid:title" => $title);
	Conifer->redis->set("board:$bid:desc" => $desc);
	
	Conifer->redis->zadd("board:list", $date_string, $bid);
	
	
	$c->redirect_to("/board");
}

sub show {
	# /(.who)/fuck/(.whom)
	my $c = shift;
	my $bid = $c->param('board');
	#~ my $who = $self->param('who') || 'anon';
	#~ my ($whom, $hash) = split/:/,$self->param('whom');
	#~ $whom ||= 'anon';
	
	#~ my $post_id = &_key_lookup("article",$hash);
	
	#~ my $title = Conifer->redis->get("board:$bid:title");
	#~ my $desc = Conifer->redis->get("board:$bid:desc");
	my $info = $c->get_board_info($bid, "title", "desc");
	
	
	#~ my @post_ids = Conifer->redis->zrange("board:$bid:posts", 0, -1);
	#~ my $post_ids = $c->get_board_posts($bid);
	my $post_ids = $c->get_list("board:$bid:posts", 0, -1);
	say "Board: list:\n\tboard_ids: ". $c->app->dumper($post_ids);
	
	my @all_posts;
	for (@$post_ids) {
		my $post_id = $_->[0];
		my %post;
		my $hash = encode_base64($post_id);
		chomp $hash;
		$hash =~ s/=//g;
		
		#~ $post{'hash'} = $hash;
		#~ $post{'title'} = Conifer->redis->get("article:$_:title");
		#~ $post{'content'} = Conifer->redis->get("article:$_:content");
		#~ $post{'author'} = Conifer->redis->get("article:$_:author");
		my ($data_id, $data) = $c->get_data($hash, "title", "content", "author");
		$data->{'hash'} = $hash;
		
		#~ push @all_posts, \%post;
		push @all_posts, $data;
	}
	
	
	#~ my $motd = "A Fuck A Day, keeps the doctor away.";
	
	$c->render(title => $info->{'title'}, desc => $info->{'desc'}, all_posts => \@all_posts);
}

sub list {
	# /(.who)/fuck/(.whom)
	my $c = shift;
	#~ my $hash = $self->param('hash');
	
	#~ my $board_ids = $c->get_board_list;
	my $board_ids = $c->get_list("board:list");
	say "Board: list:\n\tboard_ids: ". $c->app->dumper($board_ids);
	
	my @all_boards;
	for (@$board_ids) {
		my $bid = $_->[0];
		say "Board: list:\n\tCurrent board id: ". $c->app->dumper($bid);
		
		my %board = %{ $c->get_board_info($bid, "title", "desc") };
		
		$board{'id'} = $bid;
		#~ $board{'title'} = Conifer->redis->get("board:$_:title");
		#~ $board{'desc'} = Conifer->redis->get("board:$_:desc");
		
		say "Board: list:\n\tCurrent board data: ". Dumper(\%board);
		push @all_boards, \%board;
	}
	
	$c->render(all_boards => \@all_boards);
}

sub comment {
	# comments of fucks
	my $c = shift;
	my $hash = shift;
	my $id = $c->key_lookup($hash);
	my $list = Conifer->redis->get("comments:$id:list");
}

sub rank {
	# rank/score of fucks/comments
}

1;
