package Conifer::Plugin::UserHelpers;
use Mojo::Base 'Mojolicious::Plugin';
use 5.010001;
use utf8;
use List::Util 'first';
use Mojo::ByteStream 'b';
use Mojo::Util 'xml_escape';
use Time::HiRes 'time', 'gettimeofday';
use Data::Dumper::Simple;
use MIME::Base64;
use AnyEvent;

use constant DEBUG => $ENV{CONIFER_USERHELPERS_DEBUG} || 0;


sub register {
	my ($self, $app) = @_;
		
	
	# Add "get_userdata" helper
	$app->helper(
		get_userdata => sub {
			my $c = shift;
			my $hash = shift;
			my @keys = @_;
			my $aecv = AE::cv;
			
			#~ my $data_id = $app->key_lookup("data",$hash);
			
			my %data;
			$aecv->begin (sub { shift->send(\%data) });	# Outer CV
			
			for my $key (@keys) {
				$aecv->begin;	# Job CV
				#~ $data{$key} = Conifer->redis->get("data:$data_id:$key");
				Conifer->redis->get("user:$hash:$key" => sub {
					my ($redis, $res) = @_;
					say "UserHelpers: get_userdata:\n\tRedis_key: user:$hash:$key\n\tRES: ".Dumper($res);
					$data{$key} = $res->[0];
					say "UserHelpers: get_userdata:\n\tRedis_key: user:$hash:$key\n\tVALUE: $data{$key}";
					$aecv->end;
				});
			}
			
			$aecv->end;	# Outer CV
			$aecv->recv;	# non-blocking wait for all jobs
			say "UserHelpers: get_userdata:\n\tHASH: $hash\n\tDATA: ".Dumper(%data);
			
			return ( \%data );
		}
	);
	
}

1;
