package Conifer::Test;
use 5.010001;
use utf8;
use Mojo::Base 'Mojolicious::Controller';
use Data::Dumper::Simple;


sub echo {
	my $c = shift;

	my $word = $c->param('word');
	
	$c->render(message => "$word");
}

sub proxy {
	my $c = shift;
	my $url = shift;
	shift->proxy_to($url);
}

sub nested_tpl {
	my $c = shift;
	
	$c->render(outside => "outside", message => "inside");
}


sub parallel {
	$|=1;
	my $c = shift;
	my $url = $c->req->url->base.$c->url_for('info-castlist');
	#~ print "URL: $url\n";
	#~ print Dumper ($c->req->url->path);
	#~ print $c->req->url->base;
	
	$c->render_later;
	
	#~ print Dumper $c;
	
	use Mojo::UserAgent;
	#~ my $ua = Mojo::UserAgent->new;

	# Parallel requests
	my $t = Mojo::IOLoop->trigger;
	#~ my $t = $c->ua->ioloop->trigger;
	print Dumper $t;
	#~ for my $url ('mojolicio.us', 'cpan.org') {
		$t->begin;
		print "began\n";
		#~ $ua->get($url => sub {
		$c->ua->get($url => sub {
		my ($self, $tx) = @_;
			print "got it\n";
			$t->end($tx->res->dom->at('title')->text);
		});
	#~ }
	print "starting\n";
	my @titles = $t->start;
	
	print "finished\n";

	print Dumper \@titles;
	
	
	#~ $c->render(data => $titles[0]);
	$c->render(data => "lalala");
	#~ my $t = Mojo::IOLoop->trigger;
	
	# Get 'info-castlist'
	#~ $t->begin;
=a
	$c->ua->get($url, sub {
		my ($ua, $tx) = @_;
		
		if (my $res_body=$tx->success->body) {
			
			$res_body =~ s/^[\w\W]*(livemain)/<div id="$1/;
			$res_body =~ s/<div id="main">[\w\W]*$//;
			$res_body =~ s{<script[\w\W]+?</script>}{}g;
			$res_body =~ s{<span id="ad_schedule[\w\W]+?</span>}{}g;
			
			$c->render(castlist => b($res_body)->decode('UTF-8'));
			#~ $t->end("castlist: $res_body");
		} else {
			warn "failed";
			my ($msg,$error) = $tx->error;
			$c->tx->res->headers->add('X-Remote-Status',$error.': '.$msg);	
			$c->render(
				status => 500,
				text => 'Failed to fetch data from backend'
			);
			#~ $t->end("castlist: Failed to fetch data from backend.$error:$msg");
		}
	});
=cut	
	
}

sub paratest {
	my $c = shift;
	
	$c->render_later;
	
	#~ # Parallel requests
	#~ my $t = Mojo::IOLoop->trigger;
	#~ for my $url ('mojolicio.us', 'cpan.org') {
		#~ $t->begin;
		#~ $c->ua->get($url => sub {
		#~ my ($self, $tx) = @_;
			#~ $t->end($tx->res->dom->at('title')->text);
		#~ });
	#~ }
	#~ 
	#~ my @titles = $t->start;
	#~ 
	#~ $c->render(data => "$titles[0] | $titles[1]");
	
	print "TEST: paratest: We're in!\n";
	
	# Parallel non-blocking
	my $t = Mojo::IOLoop->trigger(sub {
		my ($t, @titles) = @_;
		print "TEST: paratest: Going to render!\n";
		$c->render_json(\@titles);
		#~ $c->render_data(\@titles);
	});
	for my $url ('http://mojolicio.us', 'https://metacpan.org') {
		$t->begin;
		print "TEST: paratest: Began $url\n";
		$c->ua->get($url => sub {
			my ($self, $tx) = @_;
			print "TEST: paratest: Got result from $url!\n";
			$t->end($tx->res->dom->html->head->title->text);
		});
	}
  
}

sub keygen {
	my $c = shift;
	
	my ($id, $hash) = $c->app->key_gen("test");
	
	$c->render(data => "");
}

1;
