package Conifer::User;
use 5.010001;
use utf8;
use Conifer;
use Mojo::Base 'Mojolicious::Controller';
use Time::HiRes 'time', 'gettimeofday';
use Data::Dumper;
use Digest::SHA1 qw(sha1_hex sha1_base64);
use Digest::MD5 qw(md5 md5_hex md5_base64);

$|=1;

# This action will render a template
sub login {
	# $user_passwd eq md5_base64(sha1_hex($pass))
	
	my $c = shift;
	
	# Already login
	# This check should be moved to page#login
	my $user = $c->session('name');
	if ($user) {
		$c->flash(message => 'You had logged in already!');
		$c->redirect_to('user-info');	# FIXME: redirect to user info
	}
	
	# Check username/pass are given or not
	my $name = $c->param('name') || '';
	my $pass = $c->param('pass') || '';
	unless ( $name and $pass ) {
		$c->flash(message => 'Username or Password are not given.');
		$c->redirect_to('page-login');
	}
	
	# Check if username is availible
	my $name_sha1 = sha1_hex($name);
	my $userdata = $c->get_userdata($name_sha1, 'id');
	
	# Check password
	if ($userdata->{'id'}) {
		$userdata->{'passwd'} = $c->get_userdata($name_sha1, 'passwd')->{'passwd'};
	}
	unless ( $userdata->{'passwd'} and $userdata->{'passwd'} eq md5_base64(sha1_hex($pass)) ) {
		$c->flash(message => 'Username or Password does not match.');
		$c->redirect_to('page-login');
	}
	
	
	# Login success
	
	# Set cookie
	my $login_time = $c->time_and_rand();
	$c->session(name => "$name", session => "$login_time", user_id => $userdata->{'id'});
	
	
	$c->flash(message => 'Thanks for logging in!');
	$c->redirect_to('admin');
}


sub register {
	# ('name', 'pass', 'email', 'phone')
	# ('realname', 'postal_code', 'country', 'state', 'city', 'district', 'address')
	
	# user:$id:name_sha1 = $name_sha1
	# user:name_sha1:name = $name
	# user:$name_sha1:passwd = $password
	# user:$name_sha1:id = $user_id
	
	my $c = shift;

	# Already login
	my $user = $c->session('name');
	if ($user) {
		$c->flash(message => 'You had logged in already!');
		$c->redirect_to('user-info');	# FIXME: redirect to user info
	}
	
	
	# Check if username is availible
	my $name = $c->param('name') || '';
	# FIXME: verify name string. (cannot be empty or whitespaces)
	my $name_sha1 = sha1_hex($name);
	#~ my $user_id = Conifer->redis->get("user:$name_sha1:id");
	my $user_id = $c->get_userdata($name_sha1, 'id')->{'id'};
	if ($user_id) {
		$c->flash(message => 'Sorry. The username has been taken, please use another username.');
		$c->redirect_to('user-register');	# FIXME: redirect to user info
	}
	
	
	# Check if basic columes are valid
	my $pass = $c->param('pass') || '';
	my $email = $c->param('email') || '';
	unless ($pass and $email) {	# FIXME: add string syntax verification
		$c->flash(message => 'Some basic columes are empty.');
		$c->redirect_to('user-register');	# FIXME: redirect to user info
	}
	
	
	#~ print "User/Redis: ".Dumper(Conifer->redis)."\n";
	
	
	# Create new user
	#~ my ($user_next_id) = $c->key_gen("user");
	#~ # avoid two record with the same username
	#~ Conifer->redis->setnx("user:$name_sha1:id" => $user_next_id)?
		#~ $user_id = $user_next_id
	#~ :
		#~ $user_id = $c->get_userdata($name_sha1, 'id')->{'id'}
	#~ ;
	$user_id = $c->key_gen("user");
	
	Conifer->redis->set( "user:$name_sha1:passwd" => md5_base64(sha1_hex($pass)) );
	
	# Slurp other additional columes
	# FIXME: add string syntax verification
	# ('realname', 'postal_code', 'country', 'state', 'city', 'district', 'address')
	for (qw[phone realname postal_code country state city district address]) {
		Conifer->redis->set("user:$name_sha1:$_" => $c->param($_)) if $c->param($_);
	}
	
	
	#~ print "USER ID: $user_id\n";
	
	my $login_time = $c->time_and_rand();
	$c->session(name => "$name", session => "$login_time", user_id => $user_id,);
	$c->flash(message => 'Thanks for Register!');
	$c->redirect_to('index');
	
	#~ $self->render(message => 'Welcome to the Mojolicious Web Framework! ' . $self->stash('id') );
	
}


sub logout {
	# Render template "example/welcome.html.ep" with message
	my $c = shift;
	my $user = $c->session('name');
	
	$c->session(expires => 1);
	
	# FIXME: delete from memcached
	#~ $memd->delete($user);
	
	$c->flash(message => 'You are already logged out.');
	$c->redirect_to('index');
}


sub info {
	my $c = shift;
	my $user = $c->session('name');
	my $name = $c->param('name');
	#~ my $user = $self->session('name');
	#~ $user = &check_user( $user )->{"login"} ? $user : 'Anonymous' ;
	
	#~ my $sth = $dbh->prepare("
		#~ SELECT *
		#~ FROM T_user
		#~ WHERE user_code='$user';
	#~ ");
	#~ $sth->execute();
	#~ my %userinfo = %{$sth->fetchrow_hashref()};
	#~ $sth->finish();	
	my %userinfo;	# FIXME
	
	delete $userinfo{"admin"};
	delete $userinfo{"user_code"};
	delete $userinfo{"register"};
	my $user_id = delete $userinfo{"user_id"};
	
	say $c->app->dumper(\%userinfo);
	
	$c->render(message => 'You can edit your informations here.', name => $name, userinfo => \%userinfo);
	
}


sub edit {
	my $c = shift;
	
	my $user = $c->session('name');
	if (not &check_user( $user )->{"login"}) {
		$c->flash(message => 'Please login first!');
		return $c->redirect_to('login');
	}
	
	# user name canot be changed
	my $pass = $c->param('user_passwd') || '';
	my $email = $c->param('email') || '';
	my $phone = $c->param('phone_number') || '';
	my $realname = $c->param('user_name') || '';
	my $postal_code = $c->param('postal_code') || '';
	my $country = $c->param('country') || '';
	my $state = $c->param('state') || '';
	my $city = $c->param('city') || '';
	my $district = $c->param('district') || '';
	my $address = $c->param('address') || '';
	
	print "$pass, $email, $phone, $realname, $postal_code, $country, $state, $city, $district, $address\n";
	
	# FIXME:
	# get user info from DB.
	# %userinfo = username, password, email, phone
	#~ my $sth = $dbh->prepare("
		#~ SELECT *
		#~ FROM T_user
		#~ WHERE user_code='$user';
	#~ ");
	#~ $sth->execute();
	#~ my %userinfo = %{$sth->fetchrow_hashref()};
	#~ $sth->finish();	
	
	my %userinfo;	# FIXME
	
	delete $userinfo{"admin"};
	delete $userinfo{"user_code"};
	delete $userinfo{"register"};
	my $user_id = delete $userinfo{"user_id"};
	
	say $c->app->dumper(\%userinfo);
	
	return $c->render(message => 'You can edit your informations here.', userinfo => \%userinfo) unless ($pass or $email or $phone);
	
	# check if all columes are valid
	return $c->render(message => 'Not enough information. At leaset: password, email, phone number.', userinfo => \%userinfo)
		unless ($pass && $email && $phone);
	
	# FIXME:
	# update new user info to DB
	#~ $dbh->do("
		#~ update T_user
		#~ set	user_name = '$realname',
			#~ user_passwd = '$pass',
			#~ email = '$email',
			#~ phone_number = '$phone',
			#~ postal_code = '$postal_code',
			#~ country = '$country',
			#~ state = '$state',
			#~ city = '$city',
			#~ district = '$district',
			#~ address = '$address'
		#~ where user_id = '$user_id';
	#~ ");
	
	$c->flash(message => 'User Info Updated!');
	$c->redirect_to('index');
	
}



# Functions

sub _check_user {
	my ($name, $session_name) = @_;
	my %user_status;
	#~ my $user_status = \%{()};
	my $is_admin;
	
	$user_status{"is_admin"} = $is_admin;
	
	#~ print "USER STATUS: \n" . Dumper(\%user_status) . "\n";
	
	return \%user_status;
}

1;
